import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.table.*;

//import javax.swing.event.*;

public class stmlbrowser extends JFrame{

static final long serialVersionUID=1;

int maxthreads=8;
// default Thumbnail size
int thumb_x=100;
int thumb_y=100;
boolean showgrey=true;
String defaultdir=".";

Vector thumbnails;
int fontsize=12;
boolean bo_aline=true;
GridBagConstraints c;
JScrollPane jsp;
GridLayout gl;
Stml dasparent;

Font fo;
JButton b_up,b_rup,b_rdown,b_aline,b_update;
List dirlist;
JTextField lb_dir;
JPanel innenpan;
String currentdir;
int xsize,ysize;
int yrstart=0;
int xr,yr,xo,yo;
double histo_border;
browserControlThread controlThread=null;
int maxtopo;
int curtopo;
boolean b_ctrl=false;

MenuBar menubar;
Menu m_show;
CheckboxMenuItem m_tchans[];
String columnnames[]={"Name","Value"};
JTable table;
DefaultTableModel dtabmodel;
JScrollPane jscrolltab;
Object data[][]={
		{"Hold CTRL and move Mouse to show additional information"," "},
};

void updateall() {
  int i;
  
  setTitle("JSTML Browser "+((int) (Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory())/(1024*1024))+" M of "+((int) (Runtime.getRuntime().totalMemory())/(1024*1024))+" M");
  finishControlThread();
  if (bo_aline) {b_aline.setText("AntiLine OFF");} else {b_aline.setText("AntiLine ON");}
  innenpan.removeAll();
  yrstart=0;
  // make dirlist
  File f=new File(currentdir);
  try {
    currentdir=f.getCanonicalPath();
  } catch (Exception e) {
//    JOptionPane.showMessageDialog(this,e.getMessage()+"\n Trying another Way...","File Error",JOptionPane.ERROR_MESSAGE);
    currentdir=f.getAbsolutePath();
  }
  lb_dir.setText(currentdir);
  if (!f.isDirectory()) JOptionPane.showMessageDialog(this,currentdir+" is no directory!","Directory not found Error",JOptionPane.ERROR_MESSAGE);
  String fl[] = f.list(new FilenameFilter() {
	  public boolean accept(File f, String s) {
          File fi=new File(currentdir,s);
		  return (!s.startsWith(".") && fi.isDirectory());
      }
	});
  if (fl!=null) {
	fl=sortfl(fl);
    dirlist.removeAll();
    for (i=0;i<fl.length;i++) dirlist.add(fl[i]);
    thumbnails.removeAllElements();
    System.gc();
    updatethumbs();
  }
}

	String[] sortfl(String fl[]) {
		int i;
		boolean exchanged;
		String dummy;

		if (fl != null) {
			// fl sortieren (Bubblesort)
			do {
				exchanged = false;
				for (i = 1; i < fl.length; i++) {
					if (fl[i - 1].compareToIgnoreCase(fl[i]) > 0) {
						exchanged = true;
						dummy = fl[i - 1];
						fl[i - 1] = fl[i];
						fl[i] = dummy;
					}
				}
			} while (exchanged);
		}
		return fl;
	}

	void updateview(String fl[]) {
		int i,ele,dx,cols;
		imagedata imd;
	    String svolt;
		
		innenpan.removeAll();
		for (i = 0; i < fl.length; i++) {
				for (ele = 0; ele < thumbnails.size(); ele++) {
					imd = (imagedata) thumbnails.elementAt(ele);
					if (imd.parfilename.equals(fl[i])) {
			            if (Integer.parseInt(dasparent.v_option.opts[37])>0) {
			            	svolt=imd.voltm;
			            } else {
			            	if (imd.direction.equalsIgnoreCase("Forward")) {
			            		svolt=imd.voltf;
			                	if (svolt.equalsIgnoreCase(" ")) {
			                		svolt=imd.voltm;
			                	}
			            	} else {
			            		svolt=imd.voltb;
			                	if (svolt.equalsIgnoreCase(" ")) {
			                		svolt=imd.voltm;
			                	}
			            	}
			            }
						imd.ip.setToolTipText(imd.parfilename + " / " + imd.x
								+ " x " + imd.y + " nm / " + svolt + " V "+imd.direction);
						innenpan.add(imd.ip);
						imd.ip.setSize(imd.ip.getPreferredSize());
					}
				}
			}
		dx=thumb_x+10;
		cols=jsp.getWidth()/dx;
		if (cols==0) cols++;
		gl.setColumns(cols);
		gl.setRows(0);
//		jsp.validate();
		innenpan.repaint();
//		jscrolltab.setSize(table.)
		validate();
	}
	
	void finishControlThread() {
		if (controlThread!=null) {
			controlThread.abort=true;
			while(controlThread.isAlive()) {;}
		}
		System.gc();
	}
	
void updatethumbs() {
		
	  MouseListener mlis=new MouseAdapter() {
		    public void mouseClicked(MouseEvent e) {
		    	String pname=null;
		    	imagedata imd;
		    	int ele;
		    	int but=e.getButton();
		    	boolean addIt;
		    	
		    	for(ele=0;ele<thumbnails.size();ele++) {
		    		imd=(imagedata) thumbnails.elementAt(ele);
		    		if (e.getSource().equals(imd.ip)) {
		    		  pname=imd.parfilename;
	                  System.out.println("Opening:"+currentdir+pname);
	                  if (but==3) {
	                	  addIt=true;
	                  } else{
	                	  addIt=false;
	                  }
	    	      	  dasparent.preopen(currentdir+File.separator,pname,addIt,null);
		    		}
		    	}
		    }
	  };
	  MouseMotionListener molis=new MouseMotionAdapter() {
		  public void mouseMoved(MouseEvent e) {
			   imagedata imd;
			   int ele;
			   requestFocusInWindow();
			   if (b_ctrl) {
		    	for(ele=0;ele<thumbnails.size();ele++) {
		    		imd=(imagedata) thumbnails.elementAt(ele);
		    		if (e.getSource().equals(imd.ip)) {
		    		  dtabmodel.setDataVector(imd.data,columnnames);
		    		}
		    	}
			   }
		    	//table.validate();
		    }
	  };
	  KeyListener keylis=new KeyAdapter() {
		  public void keyPressed(KeyEvent e) {
//			   requestFocusInWindow();
			  if (e.getKeyCode()==KeyEvent.VK_CONTROL) {
				  b_ctrl=true;
			  }
		  }
		  public void keyReleased(KeyEvent e) {
			  if (e.getKeyCode()==KeyEvent.VK_CONTROL) {
				  b_ctrl=false;
	    		  dtabmodel.setDataVector(data,columnnames);
			  }
		  }
	  };

	  
int i,i1;
boolean itsnew;
parList pl;
String fl[];
imagedata imd;
BufferedImage img_dummy;
JLabel jl;
String addinfo;

finishControlThread();
pl=new parList();
fl=pl.getList(currentdir);
img_dummy=new BufferedImage(thumb_x,thumb_y,BufferedImage.TYPE_INT_ARGB);
for (i=0;i<fl.length;i++) {
	itsnew=true;
    for(i1=0;i1<thumbnails.size();i1++) {
    	imd=(imagedata) (thumbnails.elementAt(i1));
    	if ( imd.parfilename.equals(fl[i]) ) itsnew=false;
    }
    if (itsnew) {
    	imd=new imagedata();
    	imd.im_shrinked=img_dummy;
    	imd.parfilename=fl[i];
    	
        imd.ip=new JPanel();
        imd.ip.setLayout(new GridBagLayout());
        GridBagConstraints gc=new GridBagConstraints();
        gc.fill=GridBagConstraints.BOTH;
        gc.insets=new Insets(1,1,1,1);
        gc.gridwidth=1;gc.gridheight=1;
        gc.weightx=gc.weighty=1.0;
        gc.gridx=0;gc.gridy=0;

        imd.jl=new JLabel(new ImageIcon(imd.im_shrinked));
        imd.ip.add(imd.jl,gc);
        gc.weightx=gc.weighty=0.0;
        gc.gridx=0;gc.gridy=1;
    	imd.jname=new JLabel(imd.parfilename);
        imd.jname.setHorizontalAlignment(SwingConstants.CENTER);
        imd.ip.add(imd.jname,gc);
        imd.ip.addMouseListener(mlis);
        imd.ip.addMouseMotionListener(molis);
        this.addKeyListener(keylis);
        imd.ip.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createRaisedBevelBorder(),BorderFactory.createRaisedBevelBorder()));
        thumbnails.add(imd);
    }
}
updateview(fl);
maxtopo=1;
controlThread=new browserControlThread(this,currentdir,bo_aline,curtopo);
controlThread.start();
}

public stmlbrowser(final Stml caller) {
  
  dasparent=caller;
  histo_border=caller.histo_border;
  defaultdir=caller.v_option.opts[0];
  if (Integer.parseInt(caller.v_option.opts[23])>0) {
    showgrey=true;
  } else {
	showgrey=false;
  }
  try {
	  maxthreads=Integer.parseInt(caller.v_option.opts[26]);
	  if (maxthreads<0) maxthreads=0;
  } catch (Exception ex) {maxthreads=0;}
  if (maxthreads==0) {
	  Runtime runtime=Runtime.getRuntime();
	  maxthreads=runtime.availableProcessors();
  }
  
  try {
    thumb_x=Integer.parseInt(caller.v_option.opts[21]);
    thumb_y=Integer.parseInt(caller.v_option.opts[22]);
  }  catch (NumberFormatException e) {
      System.out.println("ERROR: Browser evaluation thumbnail size from saved options: "+e.getMessage());
  }
  fo=new Font("SansSerif",Font.PLAIN,fontsize);
  setFont(fo);

  setTitle("Measurement Browser");
  currentdir=defaultdir;

  setLayout(new GridBagLayout());
  c=new GridBagConstraints();
  c.fill=GridBagConstraints.BOTH;
  c.insets=new Insets(6,6,6,6);
  curtopo=0;
  
  ActionListener buttonlistener=new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      String command=e.getActionCommand();
      if (command.equals("dirup")) {
        File fl=new File(currentdir);
        String updir=fl.getParent();
        if (updir == null) return;
        currentdir=updir;
        curtopo=0;
        updateall();
      }
      if (command.equals("aline")) {
      	bo_aline=!bo_aline;
        updateall();
      }
      if (command.equals("update")) {
        updatethumbs();
      }
    }
  };
  ActionListener lb_dirlistener=new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	      String cdir=lb_dir.getText();
	      File f=new File(cdir);
	      if (f.isDirectory()){
	        currentdir=cdir;
	        curtopo=0;
	    	updateall();
	      } else {
	    	JOptionPane.showMessageDialog((JTextField) e.getSource(),cdir+" is no directory!","Directory not found Error",JOptionPane.ERROR_MESSAGE);
	      }
	    }
	  };
  ActionListener dirlistener=new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      int i=dirlist.getSelectedIndex();
      File fl=new File(currentdir+File.separator+dirlist.getItem(i));
      currentdir=fl.getAbsolutePath();
      curtopo=0;
      updateall();
    }
  };
  menubar=new MenuBar();
  m_show=new Menu("Show");
  
  menubar.add(m_show);
  setMenuBar(menubar);
  
  b_up=new JButton(" .. ");
  b_up.addActionListener(buttonlistener);
  b_up.setActionCommand("dirup");
  b_up.setToolTipText("Goes a directory up");
  b_update=new JButton(" recheck ");
  b_update.addActionListener(buttonlistener);
  b_update.setActionCommand("update");
  b_update.setToolTipText("checks current directory for new files");
  
  lb_dir=new JTextField();
  lb_dir.addActionListener(lb_dirlistener);
  b_aline=new JButton();
  b_aline.addActionListener(buttonlistener);
  b_aline.setActionCommand("aline");
  dirlist=new List();
  dirlist.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
  dirlist.addActionListener(dirlistener);
  gl=new GridLayout();
  innenpan=new JPanel(gl);
  innenpan.applyComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
  
  dtabmodel=new DefaultTableModel(data,columnnames);
  table=new JTable(dtabmodel);
  jscrolltab = new JScrollPane(table);
//  table.setFillsViewportHeight(true);
//  jscrolltab.setPreferredSize(jscrolltab.getPreferredSize());

  c.weightx=c.weighty=0.0;
  c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
  add(b_up,c);
  c.gridx=1;c.gridy=0;c.gridwidth=1;c.gridheight=1;
  c.weightx=1.0;
  add(lb_dir,c);
  c.gridx=2;c.gridy=0;c.gridwidth=1;c.gridheight=1;
  c.weightx=0.0;
  add(b_update,c);
  c.gridx=3;c.gridy=0;c.gridwidth=1;c.gridheight=1;
  add(b_aline);

  c.gridx=0;c.gridy=1;c.gridwidth=1;c.gridheight=4;
  c.weightx=c.weighty=0.1;
  add(dirlist,c);
  c.gridx=1;c.gridy=1;c.gridwidth=4;c.gridheight=4;
  c.weightx=c.weighty=0.0;
  jsp=new JScrollPane(innenpan);
  jsp.getVerticalScrollBar().setUnitIncrement(thumb_y/4);
//  jsp.getViewport().setBackground(Color.BLUE);
  add(jsp,c);
  c.gridx=0;c.gridy=5;c.gridwidth=4;c.gridheight=1;
  c.weightx=c.weighty=0;
//  add(jscrolltab,c);
//  table.setAutoCreateRowSorter(true);
  add(table,c);
  table.setSize(table.getPreferredSize());

  thumbnails=new Vector();
  updateall();

  addComponentListener(new ComponentAdapter() {
    public void componentResized(ComponentEvent e) {
      updateview(new parList().getList(currentdir));
//      validate();
    }
   });

  addWindowListener(new WindowAdapter() {
    public void windowClosing(WindowEvent e) {
      System.gc();
      dispose();
    }
  });
  
}

}