import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;

import java.awt.*;

public class setImageSize extends JDialog{
	
	static final long serialVersionUID=1;

	double xsize,ysize,zstep;
	
	JLabel l_xsize,l_ysize,l_zstep;
	JTextField tf_xsize,tf_ysize,tf_zstep;
	JButton b_ok;
	
	setImageSize(Frame parent,String title) {
		
		super(parent,title,true);
        setLayout(new GridBagLayout());
        GridBagConstraints c=new GridBagConstraints();
        
        c.fill=GridBagConstraints.BOTH;
        c.insets=new Insets(5,5,5,5);
        c.weightx=c.weighty=1.0;

        l_xsize=new JLabel("physical size in X (nm): ");
        c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(l_xsize,c);
        l_ysize=new JLabel("physical size in Y (nm): ");
        c.gridx=0;c.gridy=1;c.gridwidth=1;c.gridheight=1;
        add(l_ysize,c);
        l_zstep=new JLabel("physical size of the LSB in Z (nm): ");
        c.gridx=0;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        add(l_zstep,c);

        tf_xsize=new JTextField(15);
        c.gridx=1;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(tf_xsize,c);
        tf_xsize.setActionCommand("ok");
        tf_ysize=new JTextField(15);
        c.gridx=1;c.gridy=1;c.gridwidth=1;c.gridheight=1;
        add(tf_ysize,c);
        tf_ysize.setActionCommand("ok");
        tf_zstep=new JTextField(15);
        c.gridx=1;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        add(tf_zstep,c);
        tf_zstep.setActionCommand("ok");

        b_ok=new JButton("ok");
        c.gridx=0;c.gridy=3;c.gridwidth=2;c.gridheight=1;
        add(b_ok,c);
        b_ok.setActionCommand("ok");
        
        ActionListener bal=new ActionListener() {
	          public void actionPerformed(ActionEvent e) {
	            boolean error=false;
	        	String command=e.getActionCommand();
	            if (command.equals("ok")) {
	              try {
	            	  xsize=Double.parseDouble(tf_xsize.getText());
	            	  ysize=Double.parseDouble(tf_ysize.getText());
	            	  zstep=Double.parseDouble(tf_zstep.getText());
	              } catch (Exception ex) {
                    error=true;
	            	  JOptionPane.showMessageDialog(b_ok,"Please enter a valid floating point number!","Parsing Error",JOptionPane.ERROR_MESSAGE);
	              }
	              if (!error) {
	            	  setVisible(false);
	              } else {
	            	  tf_xsize.requestFocusInWindow();
	              }
	            }
	          }
	        };

	    tf_xsize.addActionListener(bal);
	    tf_ysize.addActionListener(bal);
	    tf_zstep.addActionListener(bal);
	    b_ok.addActionListener(bal);

        
	    addWindowListener(new WindowAdapter() {
	        public void windowClosing(WindowEvent e) {
	          dispose();
	        }
	      });

	}

}
