import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;

public class thicknessDialog extends JDialog {
    
	static final long serialVersionUID = 1;
	
    JTextArea jl1;
	JTextField tf;
    JButton bok;
    double thickness=-1;
	
	thicknessDialog(Frame parent,String title) {
		super(parent,title,true);
        setLayout(new GridBagLayout());
        GridBagConstraints c=new GridBagConstraints();
        
        c.fill=GridBagConstraints.BOTH;
        c.insets=new Insets(5,5,5,5);
        c.weightx=c.weighty=1.0;

        jl1=new JTextArea("Enter the Thickness of the Profile Line\nShould be greater than 1 and smaller than Size of Topography\n for example \"1.56\" ");
        jl1.setEditable(false);
        c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(jl1,c);
        tf=new JTextField();
        c.gridx=0;c.gridy=1;;
        add(tf,c);
        tf.setActionCommand("ok");
        bok=new JButton("Ok");
        bok.setActionCommand("ok");
        c.weightx=c.weighty=0;
        c.gridx=0;c.gridy=2;
        add(bok,c);
        ActionListener bal=new ActionListener() {
	          public void actionPerformed(ActionEvent e) {
	            boolean error=false;
	        	String command=e.getActionCommand();
	            if (command.equals("ok")) {
	              try {
	            	  thickness=Double.parseDouble(tf.getText());
	              } catch (Exception ex) {
                      error=true;
	            	  JOptionPane.showMessageDialog(bok,"Please enter a valid floating point number!","Parsing Error",JOptionPane.ERROR_MESSAGE);
	              }
	              if (!error) {
	            	  setVisible(false);
	              } else {
	            	  tf.requestFocusInWindow();
	              }
	            }
	          }
	        };
	    bok.addActionListener(bal);
	    tf.addActionListener(bal);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
              thickness=-1;
              setVisible(false);
            }
          }); // WindowListener
	}
	
}
